/// <reference types="chai" />
/// <reference types="graphql" />
import { MutationBehavior, MutationQueryReducersMap } from 'apollo-client';
import { DocumentNode, FragmentDefinitionNode } from 'graphql';
export interface MutationOptions {
    variables?: Object;
    resultBehaviors?: MutationBehavior[];
    fragments?: FragmentDefinitionNode[] | FragmentDefinitionNode[][];
    optimisticResponse?: Object;
    updateQueries?: MutationQueryReducersMap;
    forceFetch?: boolean;
}
export interface QueryOptions {
    ssr?: boolean;
    variables?: {
        [key: string]: any;
    };
    forceFetch?: boolean;
    returnPartialData?: boolean;
    noFetch?: boolean;
    pollInterval?: number;
    fragments?: FragmentDefinitionNode[] | FragmentDefinitionNode[][];
    skip?: boolean;
}
export declare function withApollo(WrappedComponent: any): any;
export interface OperationOption {
    options?: Object | ((props: any) => QueryOptions | MutationOptions);
    props?: (props: any) => any;
    skip?: boolean | ((props: any) => boolean);
    name?: string;
    withRef?: boolean;
    shouldResubscribe?: (props: any, nextProps: any) => boolean;
}
export default function graphql(document: DocumentNode, operationOptions?: OperationOption): (WrappedComponent: any) => any;
